;----------------------------------------------------------------------
; Programmname : BEMURSPG.LSP    - Version: 3.0 - fr AutoCAD Version 13
; Aufgabe      :  Zerlegt eine Bamaung in Einzelelemente auf den richtigen Layer
; (c) 1997 by Ralph Kferstein, Stifterstr. 25, 67065 Ludwigshafen
; Tel./Fax: 0621 - 574658      -     Email: EDV007@aol.com
; URL: HTTP://MEMBERS.AOL.COM/EDV007.PAGE1.HTM
;----------------------------------------------------------------------
; SHAREWARE     SHAREWARE     SHAREWARE     SHAREWARE
;----------------------------------------------------------------------
; Autor: Dipl.-Ing. R. Kferstein * Stifterstr. 25 * 67065 Ludwigshafen 
; Nehme Telearbeitsprojekte aus folgenden Bereichen an:
; CAD/EDV-Dienstleistungen - CAD-Zeichen- & Konstruktionsservice
; Video-/Multimediaproduktionen, Audio/Midi-Komponist
; Softwareentwicklung (Autolisp/V-Basic/T-Basic/EXCEL/Access/Foxro)
;----------------------------------------------------------------------
; Dieses Programm knnen Sie 4 Wochen lang testen
; Bei lngerem Gebrauch mssen Sie sich bei mir registrieren lassen !!!
; Schicken Sie hierfr bitte einen Brief (1BESTELL.TXT) an die o.a.
; Adresse/Faxnummer oder per Email
;-----------------------------------------------------------------------
; Weitere Programme fr AutoCAD finden Sie in der Datei 1WEITER.TXT
;-----------------------------------------------------------------------
; Ich lehne jegliche Garantie oder Haftung fr direkte oder indirekte
; (auch konstruktive) Schden ab. Weiterhin bernehme ich keine Garantie
; fr die Funktion des Programms.
;-----------------------------------------------------------------------
; Fehlerroutine 
(defun Abbruch (s)
   (if (/= s "Function cancelled")
       (princ (strcat "\nFehler: " s))
   )
   (setvar "CLAYER" AltLayer)
   (graphscr)
   (SETVAR "cmdecho" 1)
   (SETVAR "blipmode" 1)
   (SETVAR "highlight" 1)
   (SETVAR "TEXTSIZE" AltTexthoehe)
   (SETQ *error* olderr)
   (princ)
)
;-----------------------------------------------------------------------
;Winkel von Altgrad ins Bogenma konvertieren
(defun aib (w) (* pi (/ w 180.)))
;-----------------------------------------------------------------------
; Winkel von Bogenma nach Altgrad konvertieren
(defun bia (b) (* (/ b pi) 180.))
;-----------------------------------------------------------------------
; Tangens - Funktion
(defun tan (w) (/ (sin w) (cos w)))
;-----------------------------------------------------------------------
; Arcus-Sinus - Funktion
(defun asin (x)
   (setq radi (- 1 (* x x)))
   (setq nen (sqrt radi))
   (setq arg (/ x nen))
   (setq winb (atan arg))
)
;-----------------------------------------------------------------------
; Phytagoras
(defun phyt (c a)
   (SETQ CC (* C C))
   (SETQ AA (* A A))
   (SETQ Laenge (SQRT(- CC AA)))
)
;-----------------------------------------------------------------------
;Mastabfaktor - Umrechnung
(defun mass (x) (/ x m))
;-----------------------------------------------------------------------
(defun Vorgaben ()
  (SETQ olderr  *error*)
  (SETQ *error* ABBRUCH)
  (setq AltBemFaktor (getvar "DIMLFAC"))
  (SETQ AltLayer (getvar "CLAYER"))
  (setq AltPDSIZE (getvar "pdsize"))
  (setq AltPDMODE (getvar "pdmode"))
  (SETQ AltTexthoehe (getvar "TEXTSIZE"))
  (SETVAR "cmdecho" 0)
  (SETVAR "blipmode" 0)
  (SETQ Vollinie025 "VOLL-025")
  (SETQ Vollinie035 "VOLL-035")
  (SETQ Vollinie05 "VOLL-05")
  (SETQ Vollinie07 "VOLL-07")
  (setq LOESCHEN "LOESCHEN")
  (SETQ Masslinie "BEMASSUNG")
  (SETQ Mittellinie "STRP-025")
  (SETQ Schraffurlinie "SCHRAFFUR")
  (SETQ VerdeckteLinie025 "STRI-025")
  (SETQ VerdeckteLinie035 "STRI-035")
  (SETQ Text025 "TEXT-025")
  (SETQ Text035 "TEXT-035")
  (SETQ Text05 "TEXT-05")
  (SETQ Text07 "TEXT-07")
  (prompt "\n----------------------------------------------------------------------------")
  (prompt "\n------  P R  F V E R S I O N  --  4 Wochen lang kostenlos zum Testen  -----")
  (prompt "\n----------------------------------------------------------------------------")
  (prompt "\n------------------  (c) 1997 by  Dipl.-Ing. Ralph Kferstein  --------------")
  (prompt "\n----------------------- Tel./Fax: 0 6 2 1 - 5 7 4 6 5 8  -------------------")
  (prompt "\n----------------------------------------------------------------------------")
)
;----------------------------------------------------------------------
(defun Endesequenz ()
  (setvar "DIMLFAC" AltBemFaktor)
  (setvar "CLAYER" AltLayer)
  (setvar "PDSIZE" AltPDSIZE)
  (setvar "PDMODE" AltPDMODE)
  (setvar "TEXTSIZE" AltTexthoehe)
  (graphscr)
  (SETQ *error* olderr)
  (SETVAR "blipmode" 1)
  (SETVAR "cmdecho" 1)
  (SETVAR "HIGHLIGHT" 1) 
  (PRINC)
)
;-----------------------------------------------------------------------
(defun getval (n e)
  (cdr (assoc n e))
)
;-----------------------------------------------------------------------
(defun getent (t1 / no_ent e0)
  (setq no_ent T)
  (while no_ent
    (if (setq e0 (entsel "\nWhlen Sie eine Bemaung: "))
      (if (member (getval 0 (setq e1 (entget (car e0)))) t1)
        (if (equal (getval 0 e1) "INSERT")
          (if 
                (and 
                    (equal (getval 41 e1) (getval 42 e1))
                    (equal (getval 42 e1) (getval 43 e1))
                )
            (setq no_ent nil)
            (princ "\nX, Y, und Z-Grenfaktoren mssen gleich sein.")
          )
          (setq no_ent nil)
        )
        (princ "\nObjekt ist keine Bemaung.")
      )
      (princ " Kein Objekt gefunden.")
    )
  )
)

;-----------------------------------------------------------------------
;Hauptprogramm
(DEFUN C:BEMURSPG ()
  (Vorgaben)
  (command "_layer" "_S" "BEMASSUNG" "")
  (setq e0 (entlast))
  (setq en (entnext e0))
  (while (not (null en))
    (setq e0 en)
    (setq en (entnext e0))
  )
  (getent '("INSERT" "DIMENSION" "POLYLINE"))
  (command "ursprung" (getval -1 e1))
  (setq s0 (ssadd))
  (while (entnext e0) 
      (ssadd (setq e0 (entnext e0)) s0)
  )
  (command "_chprop" s0 ""
          "_c"   "_bylayer"
          "_ltyp"  "_bylayer"
          "_la"  (getval 8 e1) "")
  (princ (strcat "\nElemente auf Layer " (getval 8 e1) " gelegt."))
  (Endesequenz)
)
