;----------------------------------------------------------------------
; Programmname : LINIEPL.LSP    - Version: 3.0 - fr AutoCAD Version 13
; Aufgabe      : Erzeugt mehrere Elemente parallel zu anderem Element
;                         mit vorher gesetztem Layer
; (c) 1997 by Ralph Kferstein, Stifterstr. 25, 67065 Ludwigshafen
; Tel./Fax: 0621 - 574658      -     Email: EDV007@aol.com
; URL: http://members.aol.com/EDV007/PAGE1.HTM
;----------------------------------------------------------------------
; SHAREWARE         S H A R E W A R E         SHAREWARE
;----------------------------------------------------------------------
; Autor: Dipl.-Ing. R. Kferstein * Stifterstr. 25 * 67065 Ludwigshafen 
; Nehme Telearbeitsprojekte aus folgenden Bereichen an:
; CAD/EDV-Dienstleistungen - CAD-Zeichen- & Konstruktionsservice
; Video-/Multimediaproduktionen, Audio/Midi-Komponist
; Softwareentwicklung (Autolisp/V-Basic/T-Basic/EXCEL/Access/Foxro)
;----------------------------------------------------------------------
; Dieses Programm knnen Sie 4 Wochen lang testen
; Bei lngerem Gebrauch mssen Sie sich bei mir registrieren lassen !!!
; Schicken Sie hierfr bitte einen Brief (1BESTELL.TXT) an die o.a.
; Adresse/Faxnummer oder per Email
; Weitere Programme fr AutoCAD finden Sie in der Datei 1README.TXT
;-----------------------------------------------------------------------
; Ich lehne jegliche Garantie oder Haftung fr direkte oder indirekte
; (auch konstruktive) Schden ab. Weiterhin bernehme ich keine Garantie
; fr die Funktion des Programms.
;-----------------------------------------------------------------------
; Fehlerroutine 
(defun Abbruch (s)
   (if (/= s "Function cancelled")
       (princ (strcat "\nFehler: " s))
   )
   (setvar "CLAYER" AltLayer)
   (graphscr)
   (SETVAR "cmdecho" 1)
   (SETVAR "blipmode" 1)
   (SETVAR "highlight" 1)
   (SETVAR "TEXTSIZE" AltTexthoehe)
   (SETQ *error* olderr)
   (princ)
)
;-----------------------------------------------------------------------
;Winkel von Altgrad ins Bogenma konvertieren
(defun aib (w) (* pi (/ w 180.)))
;-----------------------------------------------------------------------
; Winkel von Bogenma nach Altgrad konvertieren
(defun bia (b) (* (/ b pi) 180.))
;-----------------------------------------------------------------------
; Tangens - Funktion
(defun tan (w) (/ (sin w) (cos w)))
;-----------------------------------------------------------------------
; Arcus-Sinus - Funktion
(defun asin (x)
   (setq radi (- 1 (* x x)))
   (setq nen (sqrt radi))
   (setq arg (/ x nen))
   (setq winb (atan arg))
)
;-----------------------------------------------------------------------
; Phytagoras
(defun phyt (c a)
   (SETQ CC (* C C))
   (SETQ AA (* A A))
   (SETQ Laenge (SQRT(- CC AA)))
)
;-----------------------------------------------------------------------
;Mastabfaktor - Umrechnung
(defun mass (x) (/ x m))
;-----------------------------------------------------------------------
(defun Vorgaben ()
  (SETQ olderr  *error*)
  (SETQ *error* ABBRUCH)
  (setq AltBemFaktor (getvar "DIMLFAC"))
  (SETQ AltLayer (getvar "CLAYER"))
  (setq AltPDSIZE (getvar "pdsize"))
  (setq AltPDMODE (getvar "pdmode"))
  (SETQ AltTexthoehe (getvar "TEXTSIZE"))
  (SETVAR "cmdecho" 0)
  (SETVAR "blipmode" 0)
  (SETQ Vollinie025 "VOLL-025")
  (SETQ Vollinie035 "VOLL-035")
  (SETQ Vollinie05 "VOLL-05")
  (SETQ Vollinie07 "VOLL-07")
  (setq LOESCHEN "LOESCHEN")
  (SETQ Masslinie "BEMASSUNG")
  (SETQ Mittellinie "STRP-025")
  (SETQ Schraffurlinie "SCHRAFFUR")
  (SETQ VerdeckteLinie025 "STRI-025")
  (SETQ VerdeckteLinie035 "STRI-035")
  (SETQ Text025 "TEXT-025")
  (SETQ Text035 "TEXT-035")
  (SETQ Text05 "TEXT-05")
  (SETQ Text07 "TEXT-07")
  (prompt "\n----------------------------------------------------------------------------")
  (prompt "\n------  P R  F V E R S I O N  --  4 Wochen lang kostenlos zum Testen  -----")
  (prompt "\n----------------------------------------------------------------------------")
  (prompt "\n------------------  (c) 1997 by  Dipl.-Ing. Ralph Kferstein  --------------")
  (prompt "\n----------------------- Tel./Fax: 0 6 2 1 - 5 7 4 6 5 8  -------------------")
  (prompt "\n----------------------------------------------------------------------------")
)
;----------------------------------------------------------------------
(defun Endesequenz ()
  (setvar "DIMLFAC" AltBemFaktor)
  (setvar "CLAYER" AltLayer)
  (setvar "PDSIZE" AltPDSIZE)
  (setvar "PDMODE" AltPDMODE)
  (setvar "TEXTSIZE" AltTexthoehe)
  (graphscr)
  (SETQ *error* olderr)
  (SETVAR "blipmode" 1)
  (SETVAR "cmdecho" 1)
  (SETVAR "HIGHLIGHT" 1) 
  (PRINC)
)
;-----------------------------------------------------------------------
;Hauptprogramm
(DEFUN C:LINIEPL ()
  (Vorgaben)
  (setq lin1 (entsel "\nWhlen Sie bitte das Bezugselement: "))
  (if lin1
    (PROGN
      (terpri)
      (setq pt1 (cadr lin1))
      (setq ABS_LIST (list nil))
      (setq PKT_LIST (List nil))
      (setq Abbruch 1)
      (setq Abstand 1)
      (terpri)
      (while (/= Abbruch nil)
            (setq Abstand1 (RTOS Abstand 2 2))
            (setq Text (STRCAT "\ Relativer Abstand zum Element, ---> 0 = Ende : <"Abstand1"> "))  
            (SETQ Ausgabe (GETSTRING T Text))
            (if (= Ausgabe "")
              (SETQ Ausgabe Abstand1)
            )
            (setq Abstand (ATOF Ausgabe))
            (IF (= Ausgabe "0") 
              (setq Abbruch NIL)
            )
            (if Abbruch
               (progn
                 (setq seite (getpoint "Whlen Sie die Seite. "))
                 (terpri)
                 (setq ABS_LIST (append ABS_LIST (List abstand)))
                 (setq PKT_LIST (append PKT_LIST (List seite)))
               )
            )
      )   
      (setq zeiger 1)
      (repeat (- (length ABS_LIST) 1)
         (progn
            (setq abstand (nth Zeiger ABS_LIST))
            (setq seite (nth Zeiger PKT_LIST))  
            (command "_OFFSET" abstand lin1 seite "")
            (setvar "cmdecho" 0)
            (setq LLIST (entget (entlast)))
            (setq LLIST (subst (cons 8 AltLayer) (assoc 8 LLIST) LLIST))
            (entmod LLIST)
            (setq zeiger (+ zeiger 1))
         )
      )  
    )
   )
  (Endesequenz)
)
