;----------------------------------------------------------------------
; Programmname : TETEAND.LSP    - Version: 3.0 - fr AutoCAD Version 13
; Aufgabe      : ndert den Textinhalt eines ausgewhlten Textes
;                ------------ (c) 1997 by Ralph Kferstein ------------
;----------------------------------------------------------------------
; SHAREWARE   SHAREWARE   SHAREWARE   SHAREWARE   SHAREWARE   SHAREWARE
;----------------------------------------------------------------------
; Autor: Dipl.-Ing. R. Kferstein * Stifterstr. 25 * 67065 Ludwigshafen 
;        CAD/EDV-Dienstleistungen
;	 CAD-Zeichen- & Konstruktionsservice
;	 Video-/Multimediaproduktionen
;	 Softwareentwicklung (Autolisp/V-Basic/T-Basic/EXCEL/Access/Foxro)
;        Tel./Fax: 0621 - 574658
;----------------------------------------------------------------------
; ---------- Dieses Programm knnen Sie 4 Wochen lang testen ----------
; Bei lngerem Gebrauch mssen Sie sich bei mir registrieren lassen !!!
; Schicken Sie hierfr bitte einen Brief (1BESTELL.TXT) an die o.a.
; Adresse/Faxnummer.
;-----------------------------------------------------------------------
; Weitere Programme fr AutoCAD finden Sie in der Datei 1WEITER.TXT
;-----------------------------------------------------------------------
; Ich erstellte fr Sie auch firmenspez. Programme fr AutoCAD (Telearbeit)
;-----------------------------------------------------------------------
; Ich lehne jegliche Garantie oder Haftung fr direkte oder indirekte
; (auch konstruktive) Schden ab. Weiterhin bernehme ich keine Garantie
; fr die Funktion des Programms.
;-----------------------------------------------------------------------
; Fehlerroutine 
(defun Abbruch (s)
   (if (/= s "Function cancelled")
       (princ (strcat "\nFehler: " s))
   )
   (setvar "CLAYER" AltLayer)
   (graphscr)
   (SETVAR "cmdecho" 1)
   (SETVAR "blipmode" 1)
   (SETVAR "highlight" 1)
   (SETVAR "TEXTSIZE" AltTexthoehe)
   (SETQ *error* olderr)
   (princ)
)
;-----------------------------------------------------------------------
;Winkel von Altgrad ins Bogenma konvertieren
(defun aib (w) (* pi (/ w 180.)))
;-----------------------------------------------------------------------
; Winkel von Bogenma nach Altgrad konvertieren
(defun bia (b) (* (/ b pi) 180.))
;-----------------------------------------------------------------------
; Tangens - Funktion
(defun tan (w) (/ (sin w) (cos w)))
;-----------------------------------------------------------------------
; Arcus-Sinus - Funktion
(defun asin (x)
   (setq radi (- 1 (* x x)))
   (setq nen (sqrt radi))
   (setq arg (/ x nen))
   (setq winb (atan arg))
)
;-----------------------------------------------------------------------
; Phytagoras
(defun phyt (c a)
   (SETQ CC (* C C))
   (SETQ AA (* A A))
   (SETQ Laenge (SQRT(- CC AA)))
)
;-----------------------------------------------------------------------
;Mastabfaktor - Umrechnung
(defun mass (x) (/ x m))
;-----------------------------------------------------------------------
(defun Vorgaben ()
  (SETQ olderr  *error*)
  (SETQ *error* ABBRUCH)
  (setq AltBemFaktor (getvar "DIMLFAC"))
  (SETQ AltLayer (getvar "CLAYER"))
  (setq AltPDSIZE (getvar "pdsize"))
  (setq AltPDMODE (getvar "pdmode"))
  (SETQ AltTexthoehe (getvar "TEXTSIZE"))
  (SETVAR "cmdecho" 0)
  (SETVAR "blipmode" 0)
  (SETQ Vollinie025 "VOLL-025")
  (SETQ Vollinie035 "VOLL-035")
  (SETQ Vollinie05 "VOLL-05")
  (SETQ Vollinie07 "VOLL-07")
  (setq LOESCHEN "LOESCHEN")
  (SETQ Masslinie "BEMASSUNG")
  (SETQ Mittellinie "STRP-025")
  (SETQ Schraffurlinie "SCHRAFFUR")
  (SETQ VerdeckteLinie025 "STRI-025")
  (SETQ VerdeckteLinie035 "STRI-035")
  (SETQ Text025 "TEXT-025")
  (SETQ Text035 "TEXT-035")
  (SETQ Text05 "TEXT-05")
  (SETQ Text07 "TEXT-07")
  (prompt "\n----------------------------------------------------------------------------")
  (prompt "\n------  P R  F V E R S I O N  --  4 Wochen lang kostenlos zum Testen  -----")
  (prompt "\n----------------------------------------------------------------------------")
  (prompt "\n------------------  (c) 1997 by  Dipl.-Ing. Ralph Kferstein  --------------")
  (prompt "\n----------------------- Tel./Fax: 0 6 2 1 - 5 7 4 6 5 8  -------------------")
  (prompt "\n----------------------------------------------------------------------------")
)
;----------------------------------------------------------------------
(defun Endesequenz ()
  (setvar "DIMLFAC" AltBemFaktor)
  (setvar "CLAYER" AltLayer)
  (setvar "PDSIZE" AltPDSIZE)
  (setvar "PDMODE" AltPDMODE)
  (setvar "TEXTSIZE" AltTexthoehe)
  (graphscr)
  (SETQ *error* olderr)
  (SETVAR "blipmode" 1)
  (SETVAR "cmdecho" 1)
  (SETVAR "HIGHLIGHT" 1) 
  (PRINC)
)
;-----------------------------------------------------------------------
;Hauptprogramm
(DEFUN C:TETEAND ()
  (Vorgaben)
  (setq chm 0)
   (setq p (ssget))
   (if p 
     (progn
       (while(= 0 (setq osl (strlen (setq os (getstring t "\nAlter Text: ")))))
            (princ "Kein gltiger Text")
       )
       (setq nsl (strlen (setq ns (getstring t "\nNeuer Text: "))))
       (setq l 0 n (sslength p))
       (while (< l n)
         (if (= "TEXT" (cdr (assoc 0 (setq e (entget (ssname p l))))))
            (progn
               (setq chf nil si 1)
               (setq s (cdr (setq as (assoc 1 e))))
               (while (= osl (setq sl (strlen
                             (setq st (substr s si osl)))))
                  (if (= st os)
                      (progn
                        (setq s (strcat (substr s 1 (1- si)) ns
                                        (substr s (+ si osl))))
                        (setq chf t)
                        (setq si (+ si nsl))
                      )
                      (setq si (1+ si))
                  )
               )
               (if chf (progn
                  (setq e (subst (cons 1 s) as e))
                  (entmod e)
                  (setq chm (1+ chm))
               ))
           )
         )
         (setq l (1+ l))
      )
    )
  )
  (princ chm)
  (princ " Text-Zeile(n) geaendert ")
  (terpri)
  (setq *error* olderr)

  (Endesequenz)
)
