;----------------------------------------------------------------------
; Programmname : TEWEITE.LSP    - Version: 3.0 - fr AutoCAD Version 13
; Aufgabe      : ndert die Textweite von Texten
;                ------------ (c) 1997 by Ralph Kferstein ------------
;----------------------------------------------------------------------
; SHAREWARE   SHAREWARE   SHAREWARE   SHAREWARE   SHAREWARE   SHAREWARE
;----------------------------------------------------------------------
; Autor: Dipl.-Ing. R. Kferstein * Stifterstr. 25 * 67065 Ludwigshafen 
;        CAD/EDV-Dienstleistungen
;	 CAD-Zeichen- & Konstruktionsservice
;	 Video-/Multimediaproduktionen
;	 Softwareentwicklung (Autolisp/V-Basic/T-Basic/EXCEL/Access/Foxro)
;        Tel./Fax: 0621 - 574658
;----------------------------------------------------------------------
; ---------- Dieses Programm knnen Sie 4 Wochen lang testen ----------
; Bei lngerem Gebrauch mssen Sie sich bei mir registrieren lassen !!!
; Schicken Sie hierfr bitte einen Brief (1BESTELL.TXT) an die o.a.
; Adresse/Faxnummer.
;-----------------------------------------------------------------------
; Weitere Programme fr AutoCAD finden Sie in der Datei 1WEITER.TXT
;-----------------------------------------------------------------------
; Ich erstellte fr Sie auch firmenspez. Programme fr AutoCAD (Telearbeit)
;-----------------------------------------------------------------------
; Ich lehne jegliche Garantie oder Haftung fr direkte oder indirekte
; (auch konstruktive) Schden ab. Weiterhin bernehme ich keine Garantie
; fr die Funktion des Programms.
;-----------------------------------------------------------------------
; Fehlerroutine 
(defun Abbruch (s)
   (if (/= s "Function cancelled")
       (princ (strcat "\nFehler: " s))
   )
   (setvar "CLAYER" AltLayer)
   (graphscr)
   (SETVAR "cmdecho" 1)
   (SETVAR "blipmode" 1)
   (SETVAR "highlight" 1)
   (SETVAR "TEXTSIZE" AltTexthoehe)
   (SETQ *error* olderr)
   (princ)
)
;-----------------------------------------------------------------------
;Winkel von Altgrad ins Bogenma konvertieren
(defun aib (w) (* pi (/ w 180.)))
;-----------------------------------------------------------------------
; Winkel von Bogenma nach Altgrad konvertieren
(defun bia (b) (* (/ b pi) 180.))
;-----------------------------------------------------------------------
; Tangens - Funktion
(defun tan (w) (/ (sin w) (cos w)))
;-----------------------------------------------------------------------
; Arcus-Sinus - Funktion
(defun asin (x)
   (setq radi (- 1 (* x x)))
   (setq nen (sqrt radi))
   (setq arg (/ x nen))
   (setq winb (atan arg))
)
;-----------------------------------------------------------------------
; Phytagoras
(defun phyt (c a)
   (SETQ CC (* C C))
   (SETQ AA (* A A))
   (SETQ Laenge (SQRT(- CC AA)))
)
;-----------------------------------------------------------------------
;Mastabfaktor - Umrechnung
(defun mass (x) (/ x m))
;-----------------------------------------------------------------------
(defun Vorgaben ()
  (SETQ olderr  *error*)
  (SETQ *error* ABBRUCH)
  (setq AltBemFaktor (getvar "DIMLFAC"))
  (SETQ AltLayer (getvar "CLAYER"))
  (setq AltPDSIZE (getvar "pdsize"))
  (setq AltPDMODE (getvar "pdmode"))
  (SETQ AltTexthoehe (getvar "TEXTSIZE"))
  (SETVAR "cmdecho" 0)
  (SETVAR "blipmode" 0)
  (SETQ Vollinie025 "VOLL-025")
  (SETQ Vollinie035 "VOLL-035")
  (SETQ Vollinie05 "VOLL-05")
  (SETQ Vollinie07 "VOLL-07")
  (setq LOESCHEN "LOESCHEN")
  (SETQ Masslinie "BEMASSUNG")
  (SETQ Mittellinie "STRP-025")
  (SETQ Schraffurlinie "SCHRAFFUR")
  (SETQ VerdeckteLinie025 "STRI-025")
  (SETQ VerdeckteLinie035 "STRI-035")
  (SETQ Text025 "TEXT-025")
  (SETQ Text035 "TEXT-035")
  (SETQ Text05 "TEXT-05")
  (SETQ Text07 "TEXT-07")
  (prompt "\n----------------------------------------------------------------------------")
  (prompt "\n------  P R  F V E R S I O N  --  4 Wochen lang kostenlos zum Testen  -----")
  (prompt "\n----------------------------------------------------------------------------")
  (prompt "\n------------------  (c) 1997 by  Dipl.-Ing. Ralph Kferstein  --------------")
  (prompt "\n----------------------- Tel./Fax: 0 6 2 1 - 5 7 4 6 5 8  -------------------")
  (prompt "\n----------------------------------------------------------------------------")
)
;----------------------------------------------------------------------
(defun Endesequenz ()
  (setvar "DIMLFAC" AltBemFaktor)
  (setvar "CLAYER" AltLayer)
  (setvar "PDSIZE" AltPDSIZE)
  (setvar "PDMODE" AltPDMODE)
  (setvar "TEXTSIZE" AltTexthoehe)
  (graphscr)
  (SETQ *error* olderr)
  (SETVAR "blipmode" 1)
  (SETVAR "cmdecho" 1)
  (SETVAR "HIGHLIGHT" 1) 
  (PRINC)
)
;-----------------------------------------------------------------------
;Hauptprogramm
(DEFUN C:TEWEITE ()
  (Vorgaben)
  (prompt "\nZu ndernde Texte whlen. ")
  (setq Textelemente (ssget))
  (if (null Textelemente)
    (progn
      (princ "\nFEHLER: Nichts gewhlt.")
      (exit)
    )
  )
  ;**** Prfen und Aussortieren der Nichttextelemente
  (setq Anzahl (sslength Textelemente)
        nTextelemente (ssadd))
  (if (> Anzahl 25)
    (princ "\nBesttigen der gewhlten Elemente -- Bitte warten. ")
  )
  (while (> Anzahl 0)
    (setq Elemente (ssname Textelemente (setq Anzahl (1- Anzahl))))
    (if (= (cdr(assoc 0 (entget Elemente))) "TEXT")
      (ssadd Elemente nTextelemente)
    )
  )
  (setq Anzahl (sslength nTextelemente) Textelemente nTextelemente unctr 0)
  (print Anzahl)
  (princ "Textelemente gefunden. ")
  (setq unctr (1+ unctr))
  (command "ZURCK" "gruppe")
  (cht_pe "Weite")
  (command "Zurck" "ende")
  (Endesequenz)
)
;**** Hauptprozedur fr Textmanipulation ****************************
(defun cht_pe (Typ / Elemente ow WFaktorNeu ent tw sty w hw lw
                              sslen n sn Anzahl)
  (if (= (sslength Textelemente) 1)
    (cht_Ele1)
    (progn
      (initget "Liste Einzeln" 1)
      (setq WFaktorNeu (getreal (strcat"\nNeuen Weitenfaktor eingeben: ")))
      (setq sslen (sslength Textelemente))
      (setvar "highlight" 0)
      (while (> sslen 0)
        (setq Elemente (ssname Textelemente (setq sslen (1- sslen))))
        (entmod (subst (cons 41 WFaktorNeu)
                (assoc 41 (setq ent (entget Elemente)))ent))
      )
      (setvar "highlight" 1)
    )
  )
)
;********************************************************************
; Ein Texteintrag ndern
(defun cht_Ele1 ()
  (setq Elemente (ssname Textelemente 0))
  (setq ow (cdr(assoc 41 (entget Elemente))))
  (redraw (cdr(assoc -1 (entget Elemente))) 3)
  (setq WFaktorNeu (getreal (strcat 
      "\nDen neuen Weitenfaktor eingeben. <"(rtos ow 2) ">: ")))
  (if (or (= WFaktorNeu "") (= WFaktorNeu nil))
    (setq WFaktorNeu ow)
  )
  (redraw (cdr(assoc -1 (entget Elemente))) 1)
  (entmod (subst (cons 41 WFaktorNeu)(assoc 41 (setq ent (entget Elemente))) ent))
)
